$("#tutorial").on("click", function () {
  $(document).ready(async function () {
    const driver = new Driver({
      doneBtnText: "Sair",
      closeBtnText: "Fechar",
      nextBtnText: "Próximo",
      prevBtnText: "Anterior",
      allowClose: false,
    });
    driver.defineSteps([
      {
        element: "#btnFiltros",
        popover: {
          title: "Botão Filtros",
          description: "Clique aqui para filtrar a consulta dos CEPs.",
          position: "right",
        },
      },
      {
        element: "#btnNovoCEP",
        popover: {
          title: "Botão Incluir",
          description: "Clique aqui para iniciar o cadastro de um CEP.",
          position: "right",
        },
      },
      {
        element: "#tabelaCEP",
        popover: {
          title: "Tabela CEPs",
          description: "Aqui estão todos os CEPs cadastrados.",
          position: "top",
        },
      },
    ]);
    driver.start();
  });
});

$(document).ready(async function () {
  const permissaoUsuarioLogado = await permissaoAcessos("CEP");

  var ultimaColunaOrdenada = {
    nome: '',
    ordenacao: 'ASC'
  };

  function retornaBotaoOpcoes(data) {
    var retorno = '<div style="text-align:start;"> ' +
      '    <button class="btn btn-info btn-sm dropdown-toggle btnVerificaOpcoes" type="button" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false"> ' +
      '      ' + data + ' ' +
      '    </button> ' +
      '    <div class="dropdown-menu"> ' +
      '    <button class="dropdown-item" type="button" title="Editar" id="btn-editar">Editar</button>     ' +
      '    <button class="dropdown-item" type="button" title="Excluir" id="btn-excluir">Excluir</button>  ' +
      '</div>';
    return retorno;
  };

  buscarDados();

  $("#txtCidade").autocompleta(
    1,
    `JSON={ "tabela":"cidade", "camposSelect":[ "codigo chave", "NOME descricao"], "where": null}`
  );
  $("#txtPais").autocompleta(
    1,
    `JSON={ "tabela":"cadpais", "camposSelect":[ "codigo chave", "NOME descricao"], "where": null}`
  );
  $("#txtUf").autocompleta(
    1,
    `JSON={ "tabela":"tabuf", "camposSelect":[ "coduf chave", "descricao descricao"], "where": null}`
  );

  $("#btnCidade").pesquisa(
    "#txtCidade",
    "CODIGO",
    "NOME",
    `/sisplan/funcoes/v1/pesquisa?JSON={"tabela":"cidade", "camposSelect":[ "CODIGO", "NOME"]}`,
    "Pesquisa Cidade",
    "cidade"
  );
  $("#btnPais").pesquisa(
    "#txtPais",
    "CODIGO",
    "NOME",
    `/sisplan/funcoes/v1/pesquisa?JSON={"tabela":"cadpais", "camposSelect":[ "CODIGO", "NOME"]}`,
    "Pesquisa País",
    "cadpais"
  );
  $("#btnUf").pesquisa(
    "#txtUf",
    "CODUF",
    "DESCRICAO",
    `/sisplan/funcoes/v1/pesquisa?JSON={"tabela":"tabuf", "camposSelect":[ "CODUF", "DESCRICAO"]}`,
    "Pesquisa UF",
    "tabuf"
  );

  $("#btnAUf").on("click", function () {
    $("#txtUf").val("");
  });
  $("#btnAPais").on("click", function () {
    $("#txtPais").val("");
  });
  $("#btnACidade").on("click", function () {
    $("#txtCidade").val("");
  });

  $("#btnFiltros").on("click", async function () {
    $("#modal-filtros").modal("show");
  });

  $("#btnNovoCEP").on("click", async function () {
    if (permissaoUsuarioLogado.INCLUI == 'S') {
      window.location.href = "cep/create";
    } else {
      msgAlertaSemConfirmacao("Sem permissão para incluir!");
    }

  });

  $("#btnConsultar").on("click", async function () {
    await buscarDados();
    $("#modal-filtros").modal("hide");
  });

  $("#btnLimparFiltros").on("click", async function () {
    $("#txtPais").val("");
    $("#txtUf").val("");
    $("#txtCidade").val("");
  });

  async function buscarDados() {

    try {
      $.LoadingOverlay("show");
      let pais = $("#txtPais").val();
      let uf = $("#txtUf").val();
      let cidade = $("#txtCidade").val();

      let where = '';
      if (cidade != "") {
        cidade = pegaChave("#txtCidade", cidade);
        where += ` AND CODMUN = '${cidade}'`;
      }
      if (uf != "") {
        uf = pegaChave("#txtUf", uf);
        where += ` AND CODUF = '${uf}'`;
      }
      if (pais != "") {
        pais = pegaChave("#txtPais", pais);
        where += ` AND CADCEP.COD_PAIS = '${pais}'`;
      }

      $("#tabelaCEP").DataTable({
        destroy: true,
        serverSide: true,
        processing: true,
        deferRender: true,
        pageLength: 10,
        ordering: false,
        ajax: {
          url: `${getCookie('protocolo')}://${getCookie("ip_api")}/sisplan/funcoes/v1/pesquisadatatable`,
          type: "POST",
          headers: { Authorization: BASIC_AUTH },
          data: {
            EMPRESA: getCookie("empresa"),
            JSON: `{"tabela":"cadcep", "camposSelect":["cadcep.cep", "CIDADE.codigo", "CIDADE.cod_uf", "CIDADE.nome"], "innerJoin": [{"tabela": "cidade",  "condicao": "cidade.codigo = cadcep.codmun"}], "where": ["1=1 ${where}"]}`,
          },
        },
        columnDefs: [
          {
            targets: [0], render: function (data, type, row) {
              return retornaBotaoOpcoes(data);
            }
          }
        ],
      });

      $.LoadingOverlay("hide");
    } catch (error) {
      console.error(error);
      $.LoadingOverlay("hide");
    }
  }

  $("#tabelaCEP").on("click", "#btn-editar", async function () {
    if (permissaoUsuarioLogado.ALTERA == 'S') {
      let data = $("#tabelaCEP").DataTable().row($(this).parents("tr")).data();
      let clienteLiberado = true; // await liberarRegistro('CODIGO', data.CODIGO);
      if (clienteLiberado) {
        window.location.href = `cep/${data[0]}`;
      }
    } else {
      msgAlertaSemConfirmacao("Sem permissão para alterar!");
    }

  });

  $("#tabelaCEP").on("dblclick", "tr", async function () {
    if (permissaoUsuarioLogado.ALTERA == 'S') {
      let data = $("#tabelaCEP").DataTable().row($(this)).data();
      let clienteLiberado = true; // await liberarRegistro('CODIGO', data.CODIGO);
      if (clienteLiberado) {
        window.location.href = `cep/${data[0]}`;
      }
    } else {
      msgAlertaSemConfirmacao("Sem permissão para alterar!");
    }

  });

  $('#tabelaCEP').on('click', '#btn-excluir', async function () {
    if (permissaoUsuarioLogado.EXCLUI == 'S') {
      msgAlerta('Você realmente deseja excluir esse registro?', async () => {
        const data = $("#tabelaCEP").DataTable().row($(this).parents("tr"));
        await excluiRegistro(data);
      });
    } else {
      msgAlertaSemConfirmacao("Sem permissão para excluir!");
    }

  });

  async function excluiRegistro(data) {
    try {
      $.LoadingOverlay("show");
      try {
        let valorLinha = data.data();
        let response = await requisicao("DELETE", "/sisplan/cep/v1/CEP?", `CEP=${valorLinha[0]}`, null);
        if (!response) {
          return;
        }
        if (response.status != 200) {
          let jsonStr = await response.json();
          msgErro(jsonStr.mensagem);
          return;
        }

        toastr.success("Exclusão efetuada com sucesso!", "Confirmação", {
          toastClass: "success",
          iconClasses: {
            error: "alert-error",
            info: "alert-info",
            success: "alert-success",
            warning: "alert-warning",
          },
          positionClass: "toast-top-center",
          progressBar: true,
          timeOut: 3000,
          fadeOut: 1000,
          onHidden() {
            data.remove().draw(false);
          },
        }).css({
          "margin-top": "20%",
          width: "500px",
          "max-width": "500px",
        });

      } catch (error) {
        console.error(error);
      }
    } finally {
      $.LoadingOverlay("hide");
    }
  }
});
